function GenericLoadRadials(RadialSite,RadialType,FileStartNum,YearToLoad)
%
%  27 October 2008
%
%  Added Monterey Bay and Santa Cruz sites
%
%  Added SHEL - only do for ideals
%
%  GenericLoadRadials(RadialSite,RadialType,FileStartNum,YearToLoad);
%
%  Loads radials by month, based on the directory structure I've set up
%  Will have to set up to add to the "edges" of teh files later (i.e., if
%  data collecting stops in one month, then starts again in the middle of
%  the month).
%
%  FileStartNum is the number of the file to begin processing
%
%  YearToLoad added to deal with previous years as we get them
%
%  added GCve2008 (GCve from May 2008 - Oct 2008)
%
switch upper(RadialType)
    case 'IDEAL'
        RadialType='Ideal';
        FilePrefix='RDLi';
    otherwise
        RadialType='Measured';
        FilePrefix='RDLm';
end
%
if exist('YearToLoad','var'),
    GlobalDirIn=cell(1,1);
    GlobalDirIn{1}=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) num2str(YearToLoad) '/' RadialType 'All/'];
    GlobalDirOut=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) num2str(YearToLoad) '/Matlab/' RadialType];
else
    GlobalDirIn=cell(1,1);
    GlobalDirIn{1}=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) '/' RadialType 'All/'];
    GlobalDirOut=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) '/Matlab/' RadialType];
end
%
if ~exist(GlobalDirOut,'dir'),
    %
    [SUCCESS,MESSAGE,MESSAGEID] = mkdir(GlobalDirOut);
    if ~SUCCESS,
        disp('creation of output directory failed')
        disp('routine ending')
        return;
    end
end
%
if exist('YearToLoad','var'),
    RadialSiteTem=[RadialSite num2str(YearToLoad)];
else
    RadialSiteTem=RadialSite;
end
%
switch upper(RadialSiteTem)
    case 'SLID'
        SiteCode={'SLID'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2008 3 30 7];
            EndDate=[2008 6 4 14];
        else
            StartDate=[2008 3 30 7];
            EndDate=[2008 6 4 14];
        end
    case 'COMM'
        SiteCode={'COMM'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 5 31 19];
            EndDate=[2008 5 1 17];
        else
            StartDate=[2006 7 21 0];
            EndDate=[2008 5 1 17];
        end
    case 'MONT'
        SiteCode={'MONT'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 6 6 22];
            EndDate=[2008 5 11 3];
        else
            StartDate=[2006 7 21 0];
            EndDate=[2008 4 30 22];
        end
    case 'FORT'
        SiteCode={'FORT'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 8 1 15];
            EndDate=[2008 5 15 16];
        else
            StartDate=[2006 7 21 0];
            EndDate=[2008 5 15 16];
        end
    case 'BMLR'
        SiteCode={'BMLR'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 2 3 20];
            EndDate=[2008 6 12 20];
        else
            StartDate=[2007 2 3 20];
            EndDate=[2008 6 12 20];
        end
    case 'PAFS'
        %
        SiteCode={'PAFS'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 6 15 1];
            EndDate=[2008 6 12 21];
        else
            StartDate=[2007 6 15 20];
            EndDate=[2008 6 12 21];
        end
    case 'BML1'
        %
        SiteCode={'BML1'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 1 1 0];
            EndDate=[2008 6 12 20];
        else
            StartDate=[2007 1 1 0];
            EndDate=[2008 6 12 20];
        end
    case 'GCVE'
        %
        SiteCode={'GCve'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 3 8 6];
            EndDate=[2008 5 9 18];
        else
            StartDate=[2007 3 8 6];
            EndDate=[2008 5 9 18];
        end
    case 'GCVE2008'
        %
        SiteCode={'GCve'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2008 5 5 23];
            EndDate=[2008 10 10 17];
        else
            StartDate=[2008 5 5 23];
            EndDate=[2008 10 10 17];
        end
    case 'PREY'
        %
        SiteCode={'PRey'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 1 1 0];
            EndDate=[2008 6 12 22];
        else
            StartDate=[2007 1 1 0];
            EndDate=[2008 6 5 22];
        end
    case 'BML12006'
        %
        SiteCode={'BML1'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 8];
            EndDate=[2006 12 31 23];
        else
            StartDate=[2006 1 1 8];
            EndDate=[2006 12 31 23];
        end
    case 'GCVE2006'
        %
        SiteCode={'GCve'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 8];
            EndDate=[2006 11 18 20];
        else
            StartDate=[2006 1 1 8];
            EndDate=[2006 11 18 20];
        end
    case 'PREY2006'
        %
        SiteCode={'PRey'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 6 2];
            EndDate=[2006 12 31 23];
        else
            StartDate=[2006 1 6 2];
            EndDate=[2006 12 31 23];
        end
        %
        %  MONT BAY AND SCRZ SITES FOLLOW
        %
    case 'BIGC'
        SiteCode={'BIGC'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 3 16 0];
            EndDate=[2008 7 13 12];
        else
            StartDate=[2006 8 2 22];
            EndDate=[2008 7 13 12];
        end
        %
    case 'GCYN'
        SiteCode={'GCYN'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 2 10 22];
            EndDate=[2008 8 14 20];
        else
            StartDate=[2007 8 6 20];
            EndDate=[2008 8 14 20];
        end
        %
    case 'MLML'
        SiteCode={'MLML'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 11 16 2];
            EndDate=[2008 6 23 18];
        else
            StartDate=[2006 11 16 2];
            EndDate=[2008 6 23 18];
        end
        %
    case 'MLNG'
        SiteCode={'MLNG'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 0];
            EndDate=[2006 11 16 0];
        else
            StartDate=[2006 1 1 0];
            EndDate=[2006 11 16 0];
        end
        %
    case 'NPGS'
        SiteCode={'NPGS'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 0];
            EndDate=[2008 7 10 17];
        else
            StartDate=[2006 1 1 0];
            EndDate=[2008 7 10 17];
        end
        %
    case 'PESC'
        SiteCode={'PESC'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 6 8 21];
            EndDate=[2008 8 11 18];
        else
            StartDate=[2007 3 12 18];
            EndDate=[2008 4 23 19];
        end
        %        
    case 'PPIN'
        SiteCode={'PPIN'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 10 19];
            EndDate=[2008 8 22 22];
        else
            StartDate=[2006 1 10 19];
            EndDate=[2008 8 22 22];
        end
        %
    case 'PSLR'
        SiteCode={'PSLR'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 11 16 0];
            EndDate=[2008 7 25 20];
        else
            StartDate=NaN;  % means no measured files
            EndDate=NaN;
        end
        %
    case 'PSUR'
        SiteCode={'PSUR'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 0];
            EndDate=[2008 8 1 16];
        else
            StartDate=[2006 1 1 0];
            EndDate=[2007 12 22 19]; % did measured pattern go bad?
        end
        %
    case 'SCRZ'
        SiteCode={'SCRZ'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 0];
            EndDate=[2008 5 21 19];
        else
            StartDate=[2006 1 1 0];
            EndDate=[2008 5 21 19];
        end
        %
        case 'SHEL'
        SiteCode={'SHEL'};
        FileSuffix='.ruv';
        Spacing=1;  % in hours
        if isequal(RadialType,'Ideal'),
            StartDate=[2008 7 31 0];
            EndDate=[2008 10 20 2];
        else
            StartDate=NaN;
            EndDate=NaN;
        end
%
    otherwise
        disp('other sites not set up yet')
        disp('routine ending')
end
%
LogFileName=[upper(RadialSite) 'Radials' datestr(clock,30) '.txt'];  % the log file
%
if isnan(StartDate(1)),
    TemStr='No Files Present';
    AddLineToLog(GlobalDirOut,LogFileName,TemStr);
    disp('routine ending')
    pause(2);
end
%
%  Generate the time vector for all files
%
TemStart=datenum([StartDate 0 0]);
TemEnd=datenum([EndDate 0 0]);
TimeVect=TemStart:Spacing/24:TemEnd;
TemVec=datevec(TimeVect);
%
%  problem!!!! datevec routine sometimes giives 59 minutes and 60 seconds
%  instead of converting to the next hour....  check this.
%
temmark=find((TemVec(:,5)>58)&(TemVec(:,6)>58));
if numel(temmark)>0,
    disp('converting some times to next highest hour')
    disp('standard Matlab issue with datevec command')
    TemVec(temmark,4)=TemVec(temmark,4)+1;
    TemVec(temmark,5)=0;
    TemVec(temmark,6)=0;
end
%
TemVec=round(TemVec);
%
TemVecYearMonth=TemVec(:,1:2);
TemVecYearMonth=unique(TemVecYearMonth,'rows');
[NumMonths,NumCols]=size(TemVecYearMonth);
%
TemStr=['Number of Months To Process: ' num2str(NumMonths)];
AddLineToLog(GlobalDirOut,LogFileName,TemStr);
%
for jfile=FileStartNum:1:NumMonths,
    %
    if isequal(jfile,FileStartNum),
        StartClock=clock;
    end
    %
    AddLineToLog(GlobalDirOut,LogFileName,'*****');
    TemStr=['Starting Processing With File Number' num2str(jfile)];
    AddLineToLog(GlobalDirOut,LogFileName,TemStr);
    AddLineToLog(GlobalDirOut,LogFileName,'*****');
    %
    YearMonthToProcess=TemVecYearMonth(jfile,:);
    %
    temmark=find(ismember(TemVec(:,1:2),YearMonthToProcess,'rows'));
    %
    DateVectWant=TemVec(temmark,:);
    %
    [FileNamesIn,TimesForFiles]=SetUpRadialFileNames(GlobalDirIn,FilePrefix,DateVectWant,SiteCode,FileSuffix);
    %
    Rorig = loadRDLFile(FileNamesIn);
    %
    cd(GlobalDirOut);
    %
    TemFileName=[upper(RadialSite) 'Rads' RadialType 'Y' num2str(YearMonthToProcess(1)) 'M' num2str(YearMonthToProcess(2)) '.mat'];
    %
    %  must make sure that the site names for the PAFS site are the same
    %  for each structure  (used to be defined as MEND)
    %
    if isequal(upper(RadialSite),'PAFS'),
        NumTemStruct=numel(Rorig);
        [Rorig(1:NumTemStruct).SiteName]=deal('PAFS');
        [Rorig(1:NumTemStruct).SiteCode]=deal(1);
    end
    %
    save(TemFileName,'Rorig');
    %
    AddLineToLog(GlobalDirOut,LogFileName,'*****');
    TemStr=['Year ' num2str(YearMonthToProcess(1)) ' Month ' num2str(YearMonthToProcess(2)) ' Processed'];
    AddLineToLog(GlobalDirOut,LogFileName,TemStr);
    disp(TemStr)
    TemStr=['Month Number ' num2str(jfile)];
    AddLineToLog(GlobalDirOut,LogFileName,TemStr);
    AddLineToLog(GlobalDirOut,LogFileName,datestr(clock));
    %
    ElapsedTime=etime(clock,StartClock);
    ElapsedTime=(1/60)*ElapsedTime;
    %
    TemStr=['Elapsed Time in minutes since FileStartNum: ' num2str(ElapsedTime)];
    AddLineToLog(GlobalDirOut,LogFileName,TemStr);
    disp(TemStr)
    %
    AddLineToLog(GlobalDirOut,LogFileName,'*****');
    %
    clear Rorig
    %
end
%
%  the routine is done
%
return;
%
function [filenamesout,TimesOut]=SetUpRadialFileNames(DirNamesIn,FilePre,TimeVect,SiteCodes,FileSuffix)
%
%  [filenamesout,TimesOut]=SetUpRadialFileNames(DirNamesIn,FilePre,TimeVect,
%  SiteCodes,FileSuffix);
%
%  TimeVect has 6 columns, year, month, day hour minute, sec (last two
%  should be zero)
%
[NumTimes,numcols]=size(TimeVect);
NumSites=numel(SiteCodes);  % should match number of directories
%
NumFilesOut=NumSites*NumTimes;
filenamesout=cell(NumFilesOut,1);
%
%  remove the year from the TimeVector, not used in the file naming
%  convention - yes, it is for these!!!!!  Line below commented out.
%
%TimeVect(:,1)=TimeVect(:,1)-2000;
%
%  David's routines set up teh file names by time, so that they loop from site to site
%  at the same time, then change the time and start over.  I'm not sure
%  that is necessary, but let's keep the convention.
%
DirSetUp=repmat(DirNamesIn,NumTimes,1);
SiteSetUp=repmat(SiteCodes,NumTimes,1);
PrefixMat=repmat(FilePre,NumTimes,1);
SuffixMat=repmat(FileSuffix,NumTimes,1);
%
%  following a bit clugey and slow, but o.k.
%  use of reshape and deal might be better
%
TimeSetUp=NaN*ones(NumFilesOut,4);  %  year, month, day, hour
%
CurrFile=0;
%
for jtime=1:NumTimes,
    TemTime=TimeVect(jtime,1:4);
    for jsite=1:NumSites,
        CurrFile=CurrFile+1;
        TimeSetUp(CurrFile,:)=TemTime;
    end
end
%
%
SepMat=repmat('_',NumFilesOut,1);
YearMat=cellstr(num2str(TimeSetUp(:,1)));
%
%  following is done b/c of the leading zeros in months and days
%  in file names....  could be done a different way, but not worth the time.
%
MonthMat=cell(NumFilesOut,1);
DayMat=cell(NumFilesOut,1);
HourMat=cell(NumFilesOut,1);
%
for jfile=1:NumFilesOut,
    TemMonth=TimeSetUp(jfile,2);
    TemDay=TimeSetUp(jfile,3);
    TemHour=TimeSetUp(jfile,4);
    if TemMonth<10,
        TemMonthStr=['0' num2str(TemMonth)];
    else
        TemMonthStr=num2str(TemMonth);
    end
    if TemDay<10,
        TemDayStr=['0' num2str(TemDay)];
    else
        TemDayStr=num2str(TemDay);
    end
    if TemHour<10,
        TemHourStr=['0' num2str(TemHour) '00'];
    else
        TemHourStr=[num2str(TemHour) '00'];
    end
    MonthMat{jfile}=[TemMonthStr];
    DayMat{jfile}=[TemDayStr];
    HourMat{jfile}=[TemHourStr];
end
%
temnames=strcat(PrefixMat,SepMat,SiteSetUp,SepMat,YearMat,SepMat,MonthMat,SepMat,DayMat,SepMat,HourMat,SuffixMat);
%
%  The file vectors (cell strings) are all set up
%   the built in function will not work either!  Grrr.....  write my own
%
filenamesout=fullfile_multiple(DirSetUp,temnames);
%
TimesOut=TimeSetUp;
%
%  the routine is done
%
return;
%
