function GenericSecOrderRadialsStatsCleanNew(RadialSite,RadialType,FileStartNum,FileCheckSwitch)
%
%  GenericSecOrderRadialsStatsCleanNew(RadialSite,RadialType,FileStartNum,FileCheckSwitch);
%
%
%  SHEL and PAFS ideal dates modified here to match the radials we have for
%  the derivation of the eddy (July 2008 - May 2009)  21 May 2009.
%  Directory input and output also modified for this case.  Change back if
%  using this routine for other things.
%
%  if FileCheckSwitch is 1, the routine checks to see if the output file
%  exists before doing the calculations, so calculations are not repeated
%  if the routine is interrupted and then restarted.
%
%  based on GenericSecOrderRadialsStatsClean, but YearToLoad removed, as
%  all files put into one directory
%
%  redone b/c second order stats routine redone
%
%  to load the first order statistics, clean the radials, get second order
%  stats,
%  clean the radials, and save those  (this is alot!  Let's see how it
%  goes)
%
%  parameters For the first Order cleaning of radials:
%
%  Note: decrease in range generally not bad, so those flags left off in
%  the above.  Should really add for completeness, as well as the perdiff
%  flags.
%
%  YearToLoad added b/c we now have 2006 data locally
%
InitialCleaningParameters={'BML1',[0.5],'DataFound','BelowBad';'BML1',[0.5],'MatchingTimeStamps','BelowBad';...
    'PRey',[0.5],'DataFound','BelowBad';'PRey',[0.5],'MatchingTimeStamps','BelowBad';...
    'GCve',[0.5],'DataFound','BelowBad';'GCve',[0.5],'MatchingTimeStamps','BelowBad';...
    'SLID',[0.5],'DataFound','BelowBad';'SLID',[0.5],'MatchingTimeStamps','BelowBad';...
    'COMM',[0.5],'DataFound','BelowBad';'COMM',[0.5],'MatchingTimeStamps','BelowBad';...
    'MONT',[0.5],'DataFound','BelowBad';'MONT',[0.5],'MatchingTimeStamps','BelowBad';...
    'FORT',[0.5],'DataFound','BelowBad';'FORT',[0.5],'MatchingTimeStamps','BelowBad';...
    'BMLR',[0.5],'DataFound','BelowBad';'BMLR',[0.5],'MatchingTimeStamps','BelowBad';...
    'BIGC',[0.5],'DataFound','BelowBad';'BIGC',[0.5],'MatchingTimeStamps','BelowBad';...
    'GCYN',[0.5],'DataFound','BelowBad';'GCYN',[0.5],'MatchingTimeStamps','BelowBad';...
    'MLML',[0.5],'DataFound','BelowBad';'MLML',[0.5],'MatchingTimeStamps','BelowBad';...
    'MLNG',[0.5],'DataFound','BelowBad';'MLNG',[0.5],'MatchingTimeStamps','BelowBad';...
    'NPGS',[0.5],'DataFound','BelowBad';'NPGS',[0.5],'MatchingTimeStamps','BelowBad';...
    'PESC',[0.5],'DataFound','BelowBad';'PESC',[0.5],'MatchingTimeStamps','BelowBad';...
    'PPIN',[0.5],'DataFound','BelowBad';'PPIN',[0.5],'MatchingTimeStamps','BelowBad';...
    'PSLR',[0.5],'DataFound','BelowBad';'PSLR',[0.5],'MatchingTimeStamps','BelowBad';...
    'PSUR',[0.5],'DataFound','BelowBad';'PSUR',[0.5],'MatchingTimeStamps','BelowBad';...
    'SCRZ',[0.5],'DataFound','BelowBad';'SCRZ',[0.5],'MatchingTimeStamps','BelowBad';...
    'SHEL',[0.5],'DataFound','BelowBad';'SHEL',[0.5],'MatchingTimeStamps','BelowBad';...
    'PAFS',[0.5],'DataFound','BelowBad';'PAFS',[0.5],'MatchingTimeStamps','BelowBad'};
%
pause(2);
%
%  Put the second order cleaning stats here! (no - add to the directory
%  structure)
%
%  Standard Range:
%
%MaxGapTDiff=4;
%PerCovWindowSearch=8;
%SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
%
% Long Range
%
%SecOrderCleaningParameters={'No',[0.0019],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
%
%  Put the directory structure and time limits here!
%
switch upper(RadialType)
    case 'IDEAL'
        RadialType='Ideal';
    otherwise
        RadialType='Measured';
end
%
GlobalDirIn=cell(1,1);
GlobalDirIn{1}=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) '/Matlab/' RadialType '/FirstOrderStats/'];
GlobalDirOut=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) '/Matlab/' RadialType '/CleanedSecondOrder/'];
%GlobalDirIn{1}=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) '/MatlabForEddy/' RadialType '/FirstOrderStats/'];
%GlobalDirOut=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) '/MatlabForEddy/' RadialType '/CleanedSecondOrder/'];
%
if ~exist(GlobalDirOut,'dir'),
    %
    [SUCCESS,MESSAGE,MESSAGEID] = mkdir(GlobalDirOut);
    if ~SUCCESS,
        disp('creation of output directory failed')
        disp('routine ending')
        return;
    end
end
%
RadialSiteTem=RadialSite;
%
disp(['Radial Site is :' RadialSiteTem])
%
switch upper(RadialSiteTem)
    case 'BIGC'
        SiteCode={'BIGC'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/BIGCRadMaskIn.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 3 16 0];  % really only need to enter year and month of start times, but keep this way for ease
            EndDate=[2008 7 13 12];
        else
            StartDate=[2006 8 2 22];
            EndDate=[2008 7 13 12];
        end
        %
    case 'PPIN'
        SiteCode={'PPIN'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/PPINRadMaskIn.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 10 19];  % really only need to enter year and month of start times, but keep this way for ease
            EndDate=[2008 8 22 22];
        else
            StartDate=[2006 1 1 19];
            EndDate=[2008 8 22 22];
        end
        %
    case 'PESC'
        SiteCode={'PESC'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/PESCRadMaskIn.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 6 8 21];  % really only need to enter year and month of start times, but keep this way for ease
            EndDate=[2008 8 11 18];
        else
            StartDate=[2007 3 12 18];
            EndDate=[2008 4 23 19];
        end
        %
    case 'NPGS'
        SiteCode={'NPGS'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/NPGSRadMaskIn.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 1];  % really only need to enter year and month of start times, but keep this way for ease
            EndDate=[2008 7 10 17];
        else
            StartDate=[2006 1 1 1];
            EndDate=[2008 7 10 17];
        end
        %
    case 'GCYN'
        SiteCode={'GCYN'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/GCYNRadMaskIn.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 2 10 22];  % really only need to enter year and month of start times, but keep this way for ease
            EndDate=[2008 8 14 20];
        else
            StartDate=[2007 8 6 20];
            EndDate=[2008 8 14 20];
        end
        %
    case 'MLML'
        SiteCode={'MLML'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/MLMLRadMaskIn.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 11 16 2];  % really only need to enter year and month of start times, but keep this way for ease
            EndDate=[2008 6 23 18];
        else
            StartDate=[2006 11 16 2];
            EndDate=[2008 6 23 18];
        end
        %
    case 'MLNG'
        SiteCode={'MLNG'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/MLNGRadMaskIn.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 1];  % really only need to enter year and month of start times, but keep this way for ease
            EndDate=[2006 11 16 0];
        else
            StartDate=[2006 1 1 1];
            EndDate=[2006 11 16 0];
        end
        %
    case 'SLID'
        SiteCode={'SLID'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/SLIDRadialMask.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2008 3 30 7];  % really only need to enter year and month of start times, but keep this way for ease
            EndDate=[2008 6 4 14];
        else
            StartDate=[2008 3 30 7];
            EndDate=[2008 6 4 14];
        end
    case 'COMM'
        SiteCode={'COMM'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/COMMRadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 5 31 19];
            EndDate=[2008 5 1 17];
        else
            StartDate=[2006 7 21 0];
            EndDate=[2008 5 1 17];
        end
    case 'MONT'
        SiteCode={'MONT'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/MONTRadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 6 6 22];
            EndDate=[2008 5 11 3];
        else
            StartDate=[2006 7 21 0];
            EndDate=[2008 4 30 22];
        end
    case 'PSUR'
        SiteCode={'PSUR'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/PSURRadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 1];
            EndDate=[2008 8 1 16];
        else
            StartDate=[2006 1 1 1];
            EndDate=[2007 12 22 19];
        end
    case 'FORT'
        SiteCode={'FORT'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/FORTRadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 8 1 15];
            EndDate=[2008 5 15 16];
        else
            StartDate=[2006 7 21 0];
            EndDate=[2008 5 15 16];
        end
    case 'BMLR'
        SiteCode={'BMLR'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/BMLRRadialMask.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.0019],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};   % different for long range
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 2 3 20];
            EndDate=[2009 8 6 23];
        else
            StartDate=[2007 2 3 20];
            EndDate=[2009 8 6 23];
        end
    case 'PSLR'
        SiteCode={'PSLR'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/PSLRRadMaskInNoShadowZones.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.0019],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};   % different for long range
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 11 16 0];
            EndDate=[2008 7 25 20];
        else
            StartDate=[];
            EndDate=[];
        end
    case 'PAFS'
        %
        SiteCode={'PAFS'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/PAFSRadMaskInNoShadowZones.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.0019],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'}; % different for long range
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 6 15 1];
            EndDate=[2009 8 10 20];
        else
            StartDate=[2007 6 15 20];
            EndDate=[2009 8 10 20];
        end
    case 'BML1'
        SiteCode={'BML1'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/BMLRadMaskIn.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 8];
            %EndDate=[2008 6 12 20];
            EndDate=[2009 8 5 21];
        else
            StartDate=[2006 1 1 8];
            %EndDate=[2008 6 12 20];
            EndDate=[2009 7 29 21];
        end
    case 'GCVE'
        SiteCode={'GCve'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/GCVERadMaskIn.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 8];
            EndDate=[2009 7 16 22];
        else
            StartDate=[2006 1 1 8];
            EndDate=[2009 7 16 22];
        end
    case 'PREY'
        SiteCode={'PRey'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/PREYRadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 6 2];
            EndDate=[2009 8 6 23];
        else
            StartDate=[2006 1 6 2];
            EndDate=[2009 7 31 14];
        end
    case 'SCRZ'
        SiteCode={'SCRZ'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/SCRZRadMaskIn.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 1];
            EndDate=[2008 5 21 19];
        else
            StartDate=[2006 1 1 1];
            EndDate=[2008 5 21 19];
        end
    case 'SHEL'
        SiteCode={'SHEL'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/Radials/MaskInfo/SHELRadMaskInNoShadowZones.txt'}; %
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.0019],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};   % different for long range
        if isequal(RadialType,'Ideal'),
            StartDate=[2008 8 1 1];
            EndDate=[2009 5 4 14];
        else
            StartDate=[];
            EndDate=[];
        end
    otherwise
        disp('other sites not set up yet')
        disp('routine ending')
        return;
end
%
%  Loop through and load the files.
%  We will have to load files before and afterward to calculate the
%  statistics.  Extract the portions we need, concatenate, get statistics, then parse out the 
%  times we need.
%
%
LogFileName=[upper(RadialSite) 'LogSecOrderRadClean' datestr(clock,30) '.txt'];  % the log file
%
%  Set up the year / month time axis to load (will correspond to the file
%  names)
%
TemStart=datenum([StartDate 0 0]);
TemEnd=datenum([EndDate 0 0]);
TimeVect=TemStart:Spacing/24:TemEnd;
TemVec=datevec(TimeVect);
%
%  problem!!!! datevec routine sometimes gives 59 minutes and 60 seconds
%  instead of converting to the next hour....  check this.
%
temmark=find((TemVec(:,5)>58)&(TemVec(:,6)>58));
if numel(temmark)>0,
    disp('converting some times to next highest hour')
    disp('standard Matlab issue with datevec command')
    TemVec(temmark,4)=TemVec(temmark,4)+1;
    TemVec(temmark,5)=0;
    TemVec(temmark,6)=0;
end
%
TemVec=round(TemVec);
%
TemVecYearMonth=TemVec(:,1:2);
TemVecYearMonth=unique(TemVecYearMonth,'rows');
[NumMonths,NumCols]=size(TemVecYearMonth);
%
TemStr=['Number of Months To Process: ' num2str(NumMonths)];
AddLineToLog(GlobalDirOut,LogFileName,TemStr);
%
FileNamesIn=SetUpRadialFilesToSecOrderClean(GlobalDirIn,SiteCode,RadialType,TemVecYearMonth);
%
for jfile=FileStartNum:1:NumMonths,
    %
    YearMonthToProcess=TemVecYearMonth(jfile,:);
    %
    if isequal(jfile,FileStartNum),
        StartClock=clock;
    end
    %
    TemFileName=[upper(RadialSite) 'CleanSecOrderRads' RadialType 'Y' num2str(YearMonthToProcess(1)) 'M' num2str(YearMonthToProcess(2)) '.mat'];
    %
    if FileCheckSwitch,
        cd(GlobalDirOut);
        if exist(TemFileName,'file'),
            FileProcessedAlready=1;
        else
            FileProcessedAlready=0;
        end
    else
        FileProcessedAlready=0;
    end
    %
    if ~FileProcessedAlready,
        %
        AddLineToLog(GlobalDirOut,LogFileName,'*****');
        TemStr=['Starting Processing With File Number' num2str(jfile)];
        AddLineToLog(GlobalDirOut,LogFileName,TemStr);
        %
        FileFound=1;
        %
        try
            load(FileNamesIn{jfile});
            RorigCurrent=Rorig;
            RadStatsCurrent=RadialStats;
            clear Rorig RadialStats
            %
            %  get the filenames associated with the loading, so that we can
            %  keep only the relevant portions later
            %
            if ~isstruct(Rcat),
                FileFound=0;
            end
            %
        catch
            FileFound=0;
        end
        %
        if FileFound,
            %
            %  Load the file before, if possible
            %
            if jfile>1,
                try
                    %
                    load(FileNamesIn{jfile-1});
                    RorigBefore=Rorig;
                    RadStatsBefore=RadialStats;
                    clear Rorig RadialStats
                    %
                    [DataBefore,SuccessSwitch1]=ExtractData(RorigBefore,RorigCurrent,PerCovWindowSearch+2,'END');
                    [DataBeforeStats,SuccessSwitchStats]=ExtractStatsData(RadStatsBefore,RadStatsCurrent,PerCovWindowSearch+2,'END');
                    %
                    if SuccessSwitch1&&SuccessSwitchStats,
                        RorigCurrent=[DataBefore;RorigCurrent];
                        [RadStatsCurrent]=AppendHFRadarStats(DataBeforeStats,RadStatsCurrent);
                    end
                    %
                    clear RorigBefore DataBefore RadStatsBefore DataBeforeStats
                    %
                catch
                    %  do nothing
                end
            end
            %
            %  Load the file after, if possible
            %
            if jfile<NumMonths,
                try
                    %
                    load(FileNamesIn{jfile+1});
                    RorigAfter=Rorig;
                    RadStatsAfter=RadialStats;
                    clear Rorig RadialStats
                    %
                    [DataAfter,SuccessSwitch1]=ExtractData(RorigAfter,RorigCurrent,PerCovWindowSearch+2,'START');
                    [DataAfterStats,SuccessSwitchStats]=ExtractStatsData(RadStatsAfter,RadStatsCurrent,PerCovWindowSearch+2,'START');
                    %
                    if SuccessSwitch1&&SuccessSwitchStats,
                        RorigCurrent=[RorigCurrent;DataAfter];
                        [RadStatsCurrent]=AppendHFRadarStats(RadStatsCurrent,DataAfterStats);
                    end
                    %
                    clear RorigAfter DataAfter RadStatsAfter DataAfterStats
                    %
                catch
                    %  do nothing
                end
            end
            %
            %  now clean the radials
            %
            %  Empties are stripped in the routine below
            %  (CleanHFRadialsFirstOrder)
            %
            TemStr=[upper(RadialSite) ' ' RadialType 'File Number ' num2str(jfile) ' of ' num2str(NumMonths) ' Loaded'];
            disp(TemStr)
            %
            [RadOut,RStatsOut]=CleanHFRadialsFirstOrder(RorigCurrent,RadStatsCurrent,InitialCleaningParameters);
            %
            %keyboard
            %
            AddLineToLog(GlobalDirOut,LogFileName,'RadialsFirstOrderCleaned');
            %
            TemStr=[upper(RadialSite) ' ' RadialType 'File Number ' num2str(jfile) ' of ' num2str(NumMonths) ' FirstOrderCleaned'];
            disp(TemStr)
            %
            if isstruct(RadOut),
                %
                clear RorigCurrent RadStatsCurrent RStatsOut
                %
                %  mask the radials - makes the following calculations, etc.,
                %  faster
                %
                [RadOut,II]=maskRadials(RadOut,RadialMaskFile{1},true);
                %
                %keyboard
                %
                TemStr=[upper(RadialSite) ' ' RadialType 'File Number ' num2str(jfile) ' of ' num2str(NumMonths) ' Masked'];
                disp(TemStr);
                %
                Rcat = temporalConcatRadials( RadOut, 0.001, 0.49, 0.49, 0.5 );
                %
                %keyboard
                %
                AddLineToLog(GlobalDirOut,LogFileName,'FirstOrderCleanedRadialConcatenated');
                %
                TemStr=[upper(RadialSite) ' ' RadialType 'File Number ' num2str(jfile) ' of ' num2str(NumMonths) ' FirstOrderCleanedConcat'];
                disp(TemStr)
                %
                [RcatStatsSecond]=GetHFTemporalStats(Rcat,MaxGapTDiff,PerCovWindowSearch);
                %
                %keyboard
                %
                clear Rcat
                %
                AddLineToLog(GlobalDirOut,LogFileName,'Second Order Statistics Calculated');
                %
                TemStr=[upper(RadialSite) ' ' RadialType 'File Number ' num2str(jfile) ' of ' num2str(NumMonths) ' SecondOrderStatsCalc'];
                disp(TemStr)
                %
                [Rcat]=CleanHFTemporalStats(RcatStatsSecond,SecOrderCleaningParameters);
                %
                AddLineToLog(GlobalDirOut,LogFileName,'Second Order Cleaning Performed');
                %
                TemStr=[upper(RadialSite) ' ' RadialType 'File Number ' num2str(jfile) ' of ' num2str(NumMonths) ' SecondOrderStatsCleaned'];
                disp(TemStr)
                %
                clear RcatStatsSecond
                %
                [Rcat]=ExtractRelevantMonthlyData(Rcat,YearMonthToProcess);  % extract either based on
                %  file name or the year and month.  Check this.
                %
            else
                TemStr=['No Data In File'];
                AddLineToLog(GlobalDirOut,LogFileName,TemStr);
                TemStr=['Rcat set to NaN'];
                disp(TemStr)
                Rcat=NaN;
            end
            %
            TemFileName=[upper(RadialSite) 'CleanSecOrderRads' RadialType 'Y' num2str(YearMonthToProcess(1)) 'M' num2str(YearMonthToProcess(2)) '.mat'];
            %
            cd(GlobalDirOut);
            %
            save(TemFileName,'Rcat');
            %
            pause(2);
            %
            clear Rcat
            %
            TemStr=['Year ' num2str(YearMonthToProcess(1)) ' Month ' num2str(YearMonthToProcess(2)) ' Processed'];
            AddLineToLog(GlobalDirOut,LogFileName,TemStr);
            disp(TemStr)
            TemStr=['Month Number ' num2str(jfile)];
            AddLineToLog(GlobalDirOut,LogFileName,TemStr);
            AddLineToLog(GlobalDirOut,LogFileName,datestr(clock));
            %
            ElapsedTime=etime(clock,StartClock);
            ElapsedTime=(1/60)*ElapsedTime;
            %
            TemStr=['Elapsed Time in minutes since FileStartNum: ' num2str(ElapsedTime)];
            AddLineToLog(GlobalDirOut,LogFileName,TemStr);
            disp(TemStr)
            %
            AddLineToLog(GlobalDirOut,LogFileName,'*****');
            %
        else
            TemStr=['Year ' num2str(YearMonthToProcess(1)) ' Month ' num2str(YearMonthToProcess(2)) ' NOT FOUND !!!!'];
            AddLineToLog(GlobalDirOut,LogFileName,TemStr);
            disp(TemStr)
            TemStr=['Month Number ' num2str(jfile)];
            AddLineToLog(GlobalDirOut,LogFileName,TemStr);
            AddLineToLog(GlobalDirOut,LogFileName,datestr(clock));
            AddLineToLog(GlobalDirOut,LogFileName,'*****');
        end
        %
    else
        %
        TemStr=['Year ' num2str(YearMonthToProcess(1)) ' Month ' num2str(YearMonthToProcess(2)) ' Already Processed'];
        AddLineToLog(GlobalDirOut,LogFileName,TemStr);
        disp(TemStr)
        TemStr=['Month Number ' num2str(jfile)];
        AddLineToLog(GlobalDirOut,LogFileName,TemStr);
        AddLineToLog(GlobalDirOut,LogFileName,datestr(clock));
        %
    end
end
%
%  the routine is done
%
return;
%
function [FileNamesOut]=SetUpRadialFilesToSecOrderClean(DirIn,SiteCode,RadialType,YearMonthMatrix)
%
%  [FileNamesOut]=SetUpRadialFileNames(DirIn,SiteCode,RadialType,YearM
%  onthMatrix);
%
%  To set up the Matlab file names for input
%
%  YearMonthMatrix has two columns corresponding to the month and the year
%
[NumTimes,numcols]=size(YearMonthMatrix);
FileNamesOut=cell(NumTimes,1);
%
DirSetUp=repmat(DirIn,NumTimes,1);
SiteSetUp=repmat(SiteCode,NumTimes,1);
RadsSetUp=repmat('FirstOrderStatsRads',NumTimes,1);
RadTypeSetUp=repmat(RadialType,NumTimes,1);
YearCharMat=repmat('Y',NumTimes,1);
MonthCharMat=repmat('M',NumTimes,1);
%
YearMat=cellstr(num2str(YearMonthMatrix(:,1)));
MonthMat=cellstr(num2str(YearMonthMatrix(:,2)));
%
%  the above pads the months with zeros!!!!!  Not Good.
%
%  Clugey fix
%
for jmonth=1:numel(MonthMat),
    if YearMonthMatrix(jmonth,2)<=9,
        MonthMat{jmonth}=num2str(YearMonthMatrix(jmonth,2));
    end
end
%
SuffixMat=repmat('.mat',NumTimes,1);
%
TemNames=strcat(SiteSetUp,RadsSetUp,RadTypeSetUp,YearCharMat,YearMat,MonthCharMat,MonthMat,SuffixMat);
FileNamesOut=fullfile_multiple(DirSetUp,TemNames);
%
return;
%
function [DataOut,SuccessSwitch]=ExtractData(RadialsToExtract,CurrentSetOfRadials,HoursToExtract,ExtractSwitch)
%
%  [DataOut,SuccessSwitch]=ExtractData(RadialsToExtract,CurrentSetOfRadials,HoursToExtrac
%  t,ExtractSwitch);
%
%  To Extract "HoursToExtract" data.  
%
%  If ExtractSwitch is 'START', then the
%  start portion of RadialsToExtract is extracted, will be concatenated to
%  the end of CurrentSetOfRadials later.
%
%  If ExtractSwitch is 'END', then the
%  end portion of RadialsToExtract is extracted, will be stuck onto the front of 
%  CurrentSetOfRadials later.
%
%  TimeToExtract is based on the start or stop time of CurrentSetOfRadials
%  plus or minus HoursToExtract
%
%  Get the times associated with the current radial structure.  Quick but crude -
%  not assuming in time order here for some reason.
%
TimesOfCurrentRadials=NaN*ones(numel(CurrentSetOfRadials),1);
%
for jrad=1:numel(CurrentSetOfRadials),
    TimesOfCurrentRadials(jrad)=CurrentSetOfRadials(jrad).TimeStamp;
end
%
%  Get the times associated with RadialsToExtract
%
TimesOfRadialsToExtract=NaN*ones(numel(RadialsToExtract),1);
%
for jrad=1:numel(RadialsToExtract),
    TimesOfRadialsToExtract(jrad)=RadialsToExtract(jrad).TimeStamp;
end
%
switch upper(ExtractSwitch)
    case 'START'
        %
        TimeCut=nanmax(TimesOfCurrentRadials)+((1/24)*HoursToExtract)+0.005;  %just in case of roundoff
        %
        TimeIndices=find(TimesOfRadialsToExtract<=TimeCut);
        %
    case 'END'
        %
        TimeCut=nanmin(TimesOfCurrentRadials)-((1/24)*HoursToExtract)-0.005;  %just in case of roundoff
        %
        TimeIndices=find(TimesOfRadialsToExtract>=TimeCut);
        %
end
%
if numel(TimeIndices)>=1,
    %
    DataOut=RadialsToExtract(TimeIndices);
    SuccessSwitch=1;
    %
else
    %
    DataOut=NaN;
    SuccessSwitch=0;
    %
end
%
%  the routine is done
%
return;
%
function [DataOut,SuccessSwitch]=ExtractStatsData(StatsToExtract,CurrentSetOfStats,HoursToExtract,ExtractSwitch)
%
%  [DataOut,SuccessSwitch]=ExtractStatsData(StatsToExtract,CurrentSetOfStat
%  s,HoursToExtract,ExtractSwitch);
%
%  To Extract "HoursToExtract" data.  
%
%  If ExtractSwitch is 'START', then the
%  start portion of StatsToExtract is extracted, will be concatenated to
%  the end of CurrentSetOfStats later.
%
%  If ExtractSwitch is 'END', then the
%  end portion of StatsToExtract is extracted, will be stuck onto the front of 
%  CurrentSetOfStats later.
%
%  TimeToExtract is based on the start or stop time of CurrentSetOfStats
%  plus or minus HoursToExtract
%
%  Get the times associated with the current stats structure.  Quick but crude -
%  not assuming in time order here for some reason.
%
%  Assuming time stamps match here!!!!!  So if mismatch, the problem has
%  been fixed.
%
switch upper(ExtractSwitch)
    case 'START'
        %
        TimeCut=nanmax(CurrentSetOfStats.FileTimeStamp)+((1/24)*HoursToExtract)+0.005;  %just in case of roundoff
        %
        TimeIndices=find(StatsToExtract.FileTimeStamp<=TimeCut);
        %
    case 'END'
        %
        TimeCut=nanmin(CurrentSetOfStats.FileTimeStamp)-((1/24)*HoursToExtract)-0.005;  %just in case of roundoff
        %
        TimeIndices=find(StatsToExtract.FileTimeStamp>=TimeCut);
        %
end
%
if numel(TimeIndices)>=1,
    %
    [DataOut]=ExtractFieldsFromStruct(StatsToExtract,TimeIndices,1);
    SuccessSwitch=1;
    %
else
    %
    DataOut=NaN;
    SuccessSwitch=0;
    %
end
%
%  the routine is done
%
return;
%
function [RcatOut]=ExtractRelevantMonthlyData(RcatIn,YearMonthToExtract)
%
%  [RcatOut]=ExtractRelevantMonthlyData(RcatIn,YearMonthToExtract);
%
%  Extract the dat abased on the Year and Month
%
%  works only based on year and month (don't pass multiple years)
%
TemTimeAxis=RcatIn.TimeStamp';
%
TemVec=datevec(TemTimeAxis);
%
%  problem!!!! datevec routine sometimes gives 59 minutes and 60 seconds
%  instead of converting to the next hour....  check this.
%
temmark=find((TemVec(:,5)>58)&(TemVec(:,6)>58));
if numel(temmark)>0,
    disp('converting some times to next highest hour')
    disp('standard Matlab issue with datevec command')
    TemVec(temmark,4)=TemVec(temmark,4)+1;
    TemVec(temmark,5)=0;
    TemVec(temmark,6)=0;
end
%
TemVec=round(TemVec);
%
TemVecYearMonth=TemVec(:,1:2);
%
TimeIndices=find(ismember(TemVecYearMonth,YearMonthToExtract,'rows'));
%
if numel(TimeIndices)<1,
    RcatOut=NaN;
else
    [NumPoints,NumCols]=size(RcatIn.LonLat);
    RcatOut=subsrefRADIAL(RcatIn,[1:NumPoints],TimeIndices);
end
%
%  the routine is done
%
return;
%
    


