function [TUVOut] = temporalInterpTotalsInterface(TUVIn,TimeStampIn,TimeGapInterp)
%
%  [TUVOut] = temporalInterpTotalsInterface(TUVIn,TimeStampIn,TimeGapInterp);
%
%  Finally written!  (Instead of chopping input into pieces).
%   Interfaces to DMK temporalInterpTotals routine, b/c that is a real
%   memory hog
%
%  (TimeStampIn should be the same as the TUVIn)!!!!!
%
NominalMaxColumnsInterp=30;  % to decrease the demands on the memory
%
%  how many columns on either side should we get for interpolation?
%
TimeDiff=nanmedian(TimeStampIn(2:numel(TimeStampIn))-TimeStampIn(1:numel(TimeStampIn)-1));
ColsExtra=ceil(TimeGapInterp/TimeDiff)+2;  % really only need to add one column, but adding two in case of roundoff
%
TUVOut=TUVIn;
%
NumTotalColumns=numel(TUVIn.TimeStamp);
%
[NumPos,NumCol]=size(TUVIn.LonLat);
PositionExtract=1:NumPos;
%
FirstColumnToObtain=1;
%
while FirstColumnToObtain<NumTotalColumns,
    %
    LastColumnToObtain=FirstColumnToObtain+NominalMaxColumnsInterp-1;
    if LastColumnToObtain>NumTotalColumns,
        LastColumnToObtain=NumTotalColumns;
    end
    %
    if ~isequal(FirstColumnToObtain,LastColumnToObtain),
        %
        if isequal(FirstColumnToObtain,1),
            FirstColumnToExtract=FirstColumnToObtain;
        else
            FirstColumnToExtract=FirstColumnToObtain-ColsExtra;
        end
        if FirstColumnToExtract<1,
            FirstColumnToExtract=1;
        end
        %
        if isequal(LastColumnToObtain,NumTotalColumns),
            LastColumnToExtract=NumTotalColumns;
        else
            LastColumnToExtract=LastColumnToObtain+ColsExtra;
        end
        if LastColumnToExtract>NumTotalColumns,
            LastColumnToExtract=NumTotalColumns;
        end
        %
        TimeExtractIndex=FirstColumnToExtract:LastColumnToExtract;
        %
        FirstIndexOffset=FirstColumnToObtain-FirstColumnToExtract;
        FirstExtractedIndex=FirstIndexOffset+1;  % column of the extracted matrix where the time matched
        %  the time of the larger matrix
        LastExtractedIndex=FirstExtractedIndex+(LastColumnToObtain-FirstColumnToObtain);  % should be nor errors
        %  this way.  Leave as a check.
        %
        try
            %
            [TUVportion]=subsrefTUV(TUVIn,PositionExtract,TimeExtractIndex);
            %
            TUVportion = temporalInterpTotals(TUVportion,TUVportion.TimeStamp,TimeGapInterp);
            %
        catch
            [TUVportion]=subsrefTUV(TUVIn,PositionExtract,TimeExtractIndex,false,false);
            %
            TUVportion = temporalInterpTotals(TUVportion,TUVportion.TimeStamp,TimeGapInterp,false,false);
            %
        end
        %  now replace the appropriate columns
        %
        TUVOut.U(:,FirstColumnToObtain:LastColumnToObtain)=TUVportion.U(:,FirstExtractedIndex:LastExtractedIndex);
        TUVOut.V(:,FirstColumnToObtain:LastColumnToObtain)=TUVportion.V(:,FirstExtractedIndex:LastExtractedIndex);
        %
        %  Set FirstColumnToObtain
        %
    end
    %
    FirstColumnToObtain=FirstColumnToObtain+NominalMaxColumnsInterp;
    %
end
%
%  the routine is done
%
return;
%
