function CreateRadialMaskMoreSites()
%
%  CreateRadialMaskMoreSites;
%
%  to look at old masks (from Kaplan), save if I like them, create new ones
%  if not
%
%  ALso create new masks that I don't have
%
%  CreateRadialMaskSHEL();
%
%  modified from CreateRadialMaskNewSites();
%
%  modifed for SHEL, and also to create a new mask for PAFS without shadow
%  zones north of the point.  SHEL parameters commented out for PAFS.
%
%  modified - creates radial masks for all sites!!!!  Mont and SCRZ sites
%
%  prompts the user for which of the seven sites to create the radial mask for
%
%  masks will be used as inclusive - so radials inside the mask will be
%  kept.  Gerstle Cove not included at this point.
%
%  FileToSave is the name of a text file to contain the output.  Names such
%  as 'BMLRadMaskIn.txt' are suggested.  BML means the BML CODAR, Radial
%  mask is obvious, and In means to keep radials within the polygon.
%
%  Gerstle Cove added, 16 Nov 2007.  CoastFileDir changed for this case.
%
%  SLID added 18 June 2008.
%
CoastFileLocation=fullfile('/Users/chrishalle/Documents/CMHToolbox/TemMakeRadMasks','WestCoastMap.mat');
DirRadials='/Users/chrishalle/Documents/CMHToolbox/TemMakeRadMasks';
DirPossibleMasks='/Users/chrishalle/Documents/CMHToolbox/TemMakeRadMasks/MaskInfo/PossibleMasks';
DirMasksOut='/Users/chrishalle/Documents/CMHToolbox/TemMakeRadMasks/MaskInfo/NewlyMadeCheckedMasks';
%
SiteList=cell(8,1);
SiteList{1}='GCYN';
SiteList{2}='MLML';
SiteList{3}='MLNG';
SiteList{4}='NPGS';
SiteList{5}='PPIN';
SiteList{6}='PSLR';
SiteList{7}='PSUR';
SiteList{8}='SCRZ';
%
DistAroundSite=NaN*ones(8,1);
DistAroundSite(1)=120;
DistAroundSite(2)=60;
DistAroundSite(3)=60;
DistAroundSite(4)=120;
DistAroundSite(5)=120;
DistAroundSite(6)=240;
DistAroundSite(7)=120;
DistAroundSite(8)=120;
%
IdealFileNames=cell(8,1);
IdealFileNames{1}='GCYNRadsIdealY2006M6.mat';
IdealFileNames{2}='MLMLRadsIdealY2007M5.mat';
IdealFileNames{3}='MLNGRadsIdealY2006M6.mat';
IdealFileNames{4}='NPGSRadsIdealY2006M8.mat';
IdealFileNames{5}='PPINRadsIdealY2006M7.mat';
IdealFileNames{6}='PSLRRadsIdealY2008M3.mat';
IdealFileNames{7}='PSURRadsIdealY2007M3.mat';
IdealFileNames{8}='SCRZRadsIdealY2007M5.mat';
%
OldMasksToCheck=cell(8,1);
OldMasksToCheck{1}='None';
OldMasksToCheck{2}='None';
OldMasksToCheck{3}='None';
OldMasksToCheck{4}='NPGS.mask';
OldMasksToCheck{5}='PPIN.mask';
OldMasksToCheck{6}='None';
OldMasksToCheck{7}='None';
OldMasksToCheck{8}='SCRZ.mask';
%
%for jsite=1:numel(SiteList),
for jsite=7:numel(SiteList),
    %
    cd(DirRadials);
    %
    load(char(IdealFileNames{jsite}));
    %
    if isequal(jsite,6),
        Rorig(1)=Rorig(numel(Rorig));
    end
    %
    NumRorig=numel(Rorig);
    %
    %  Step 1 - Get Map Limits
    %
    [LeftLon,lattem,a21]=m_fdist(Rorig(1).SiteOrigin(1),Rorig(1).SiteOrigin(2),270,1000*DistAroundSite(jsite),'wgs84');
    if LeftLon>0,
        LeftLon=LeftLon-360;
    end
    %
    [RightLon,lattem,a21]=m_fdist(Rorig(1).SiteOrigin(1),Rorig(1).SiteOrigin(2),90,1000*DistAroundSite(jsite),'wgs84');
    if RightLon>0,
        RightLon=RightLon-360;
    end
    %
    [lontem,TopLat,a21]=m_fdist(Rorig(1).SiteOrigin(1),Rorig(1).SiteOrigin(2),0,1000*DistAroundSite(jsite),'wgs84');
    %
    [lontem,BotLat,a21]=m_fdist(Rorig(1).SiteOrigin(1),Rorig(1).SiteOrigin(2),180,1000*DistAroundSite(jsite),'wgs84');
    %
    MapXLims=[LeftLon RightLon];
    MapYLims=[BotLat TopLat];
    %
    MapXLimsHRes=[Rorig(1).SiteOrigin(1)-0.1 Rorig(1).SiteOrigin(1)+0.1];
    MapYLimsHRes=[Rorig(1).SiteOrigin(2)-0.1 Rorig(1).SiteOrigin(2)+0.1];
    %
    TemFigHandle=figure;
    %
    plotBasemap(MapXLimsHRes,MapYLimsHRes,CoastFileLocation,'lambert', 'patch', [0.5 0.5 0.5] );
    hold
    m_plot(Rorig(1).SiteOrigin(1),Rorig(1).SiteOrigin(2),'r.','MarkerSize',[8])
    m_plot(Rorig(NumRorig).SiteOrigin(1),Rorig(NumRorig).SiteOrigin(2),'r+','MarkerSize',[8])
    TemStr=['Map Only, High Res, Site ' Rorig(1).SiteName];
    title(TemStr)
    %
    pause(3);
    %
    TemFigHandle2=figure;
    %
    plotBasemap(MapXLims,MapYLims,CoastFileLocation,'lambert', 'patch', [0.5 0.5 0.5] );
    hold
    m_plot(Rorig(1).SiteOrigin(1),Rorig(1).SiteOrigin(2),'r.','MarkerSize',[8])
    m_plot(Rorig(NumRorig).SiteOrigin(1),Rorig(NumRorig).SiteOrigin(2),'r+','MarkerSize',[8])
    TemStr=['Site ' Rorig(1).SiteName];
    title(TemStr)
    %
    NumRorig=numel(Rorig);
    DataSet1=Rorig(1);
    DataSet2=Rorig(round(NumRorig/2));
    DataSet3=Rorig(NumRorig-5);
    %
    if abs(nansum(DataSet1.U))>0,
        [handles,TimeIndex]=plotData(DataSet1,'m_vec',1,0.01);
    end
    %
    if abs(nansum(DataSet2.U))>0,
        [handles,TimeIndex]=plotData(DataSet2,'m_vec',1,0.01);
    end
    %
    if abs(nansum(DataSet3.U))>0,
        [handles,TimeIndex]=plotData(DataSet3,'m_vec',1,0.01);
    end
    %
    %  if there is already a radial mask, plot it
    %
    switch upper(char(OldMasksToCheck{jsite}))
        case 'NONE'
            %
            %  do nothing
            %
            MaskSetYet='NO';
            %
        otherwise
            %
            cd(DirPossibleMasks);
            %
            TemFileName=char(OldMasksToCheck{jsite});
            %
            [mask,filename,check]=loadDataFileWithChecks(TemFileName);
            %
            MaskHandle=m_plot(mask(:,1),mask(:,2),'k','LineWidth',[2]);
            %
            MaskCheck=questdlg('Look at the mask, hit return when done','Check Mask','OK','OK','OK');
            %
            pause
            %
            MaskCheck=questdlg('Does the mask look o.k.?','Check Mask','Yes','No','Yes');
            %
            if isequal(upper(MaskCheck),'YES'),
                MaskSetYet='YES';
            else
                MaskSetYet='NO';
                delete(MaskHandle);
            end
            %
    end
    %
    if isequal(MaskSetYet,'NO'),
        %
        disp('you will be prompted for masks')
        disp('hit return to continue')
        disp('pick starting / ending points near the site,')
        disp('mask will be set to site origin')
        pause
        %
        MaskOK=0;
        %
        while ~MaskOK,
            %
            [X,Y,ptHand,lineHand] = makePoly('m_ginput');
            %
            %  replace first and last point with the CODAR position
            %
            X(1)=Rorig(1).SiteOrigin(1);
            X(numel(X))=Rorig(1).SiteOrigin(1);
            %
            Y(1)=Rorig(1).SiteOrigin(2);
            Y(numel(Y))=Rorig(1).SiteOrigin(2);
            %
            MaskHandle=m_plot(X,Y,'k','LineWidth',[2]);
            %
            MaskCheck=questdlg('Does the mask look o.k.?','Check Mask','Yes','No','Yes');
            %
            if isequal(upper(MaskCheck),'YES'),
                MaskOK=1;
                MaskSetYet='YES';
                mask=[X Y];
            else
                MaskOK=0;
                delete(MaskHandle);
            end
            %
        end
        %
    end
    %
    %  we should have the mask by this point
    %
    cd(DirMasksOut);
    %
    FileToSave=[char(SiteList{jsite}) 'RadMaskIn.txt'];
    [yout]=PutOutTextFile4sig(mask,FileToSave);
    %
    delete(TemFigHandle);
    delete(TemFigHandle2);
    %
end
%
%  the routine is done
%
return;
%
