function GenericFirstOrderCleanRadials(RadialSite,RadialType,FileStartNum)
%
%  GenericFirstOrderCleanRadials(RadialSite,RadialType,FileStartNum);
%
%  First Order cleaning of radials.
%
%
%  Note: decrease in range generally not bad, so those flags left off in
%  the above.  Should really add for completeness, as well as the perdiff
%  flags.
%
CleaningParameters={'BML1',[0.5],'DataFound','BelowBad';'BML1',[0.5],'MatchingTimeStamps','BelowBad';...
    'PRey',[0.5],'DataFound','BelowBad';'PRey',[0.5],'MatchingTimeStamps','BelowBad';...
    'GCve',[0.5],'DataFound','BelowBad';'GCve',[0.5],'MatchingTimeStamps','BelowBad';...
    'SLID',[0.5],'DataFound','BelowBad';'SLID',[0.5],'MatchingTimeStamps','BelowBad';...
    'COMM',[0.5],'DataFound','BelowBad';'COMM',[0.5],'MatchingTimeStamps','BelowBad';...
    'MONT',[0.5],'DataFound','BelowBad';'MONT',[0.5],'MatchingTimeStamps','BelowBad';...
    'FORT',[0.5],'DataFound','BelowBad';'FORT',[0.5],'MatchingTimeStamps','BelowBad';...
    'BMLR',[0.5],'DataFound','BelowBad';'BMLR',[0.5],'MatchingTimeStamps','BelowBad';...
    'PAFS',[0.5],'DataFound','BelowBad';'PAFS',[0.5],'MatchingTimeStamps','BelowBad'};
%
switch upper(RadialType)
    case 'IDEAL'
        RadialType='Ideal';
    otherwise
        RadialType='Measured';
end
%
GlobalDirIn=cell(1,1);
GlobalDirIn{1}=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) '/Matlab/' RadialType '/FirstOrderStats/'];
GlobalDirOut=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) '/Matlab/' RadialType '/FirstOrderStats/CleanedFirstOrder/'];
%
if ~exist(GlobalDirOut,'dir'),
    %
    [SUCCESS,MESSAGE,MESSAGEID] = mkdir(GlobalDirOut);
    if ~SUCCESS,
        disp('creation of output directory failed')
        disp('routine ending')
        return;
    end
end
%
switch upper(RadialSite)
    case 'SLID'
        SiteCode={'SLID'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CMHToolbox/NationalParkStudy/SLIDRadialMask.txt'}; % !!!!  change
        if isequal(RadialType,'Ideal'),
            StartDate=[2008 3 30 7];  % really only need to enter year and month of start times, but keep this way for ease
            EndDate=[2008 6 4 14];
        else
            StartDate=[2008 3 30 7];
            EndDate=[2008 6 4 14];
        end
    case 'COMM'
        SiteCode={'COMM'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CMHToolbox/NationalParkStudy/COMMRadMaskIn.txt'}; % !!!!  change
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 5 31 19];
            EndDate=[2008 5 1 17];
        else
            StartDate=[2006 7 21 0];
            EndDate=[2008 5 1 17];
        end
    case 'MONT'
        SiteCode={'MONT'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CMHToolbox/NationalParkStudy/MONTRadMaskIn.txt'}; % !!!!  change
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 6 6 22];
            EndDate=[2008 5 11 3];
        else
            StartDate=[2006 7 21 0];
            EndDate=[2008 4 30 22];
        end
    case 'FORT'
        SiteCode={'FORT'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CMHToolbox/NationalParkStudy/FORTRadMaskIn.txt'}; % !!!!  change
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 8 1 15];
            EndDate=[2008 5 15 16];
        else
            StartDate=[2006 7 21 0];
            EndDate=[2008 5 15 16];
        end
    case 'BMLR'
        SiteCode={'BMLR'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/LongRangeNearBML/ProcessingInfo/BMLRRadialMask.txt'}; % !!!!  change
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 2 3 20];
            EndDate=[2008 6 12 20];
        else
            StartDate=[2007 2 3 20];
            EndDate=[2008 6 12 20];
        end
    case 'PAFS'
        %
        SiteCode={'PAFS'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/LongRangeNearBML/ProcessingInfo/MENDRadialMask.txt'}; % !!!!  change
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 6 15 1];
            EndDate=[2008 6 12 21];
        else
            StartDate=[2007 6 15 20];
            EndDate=[2008 6 12 21];
        end
    otherwise
        disp('other sites not set up yet')
        disp('routine ending')
end
%
LogFileName=[upper(RadialSite) 'RadialFirstOrderClean' datestr(clock,30) '.txt'];  % the log file
%
%  Set up the year / month time axis to load (will correspond to the file
%  names)
%
TemStart=datenum([StartDate 0 0]);
TemEnd=datenum([EndDate 0 0]);
TimeVect=TemStart:Spacing/24:TemEnd;
TemVec=datevec(TimeVect);
%
%  problem!!!! datevec routine sometimes gives 59 minutes and 60 seconds
%  instead of converting to the next hour....  check this.
%
temmark=find((TemVec(:,5)>58)&(TemVec(:,6)>58));
if numel(temmark)>0,
    disp('converting some times to next highest hour')
    disp('standard Matlab issue with datevec command')
    TemVec(temmark,4)=TemVec(temmark,4)+1;
    TemVec(temmark,5)=0;
    TemVec(temmark,6)=0;
end
%
TemVec=round(TemVec);
%
TemVecYearMonth=TemVec(:,1:2);
TemVecYearMonth=unique(TemVecYearMonth,'rows');
[NumMonths,NumCols]=size(TemVecYearMonth);
%
TemStr=['Number of Months To Process: ' num2str(NumMonths)];
AddLineToLog(GlobalDirOut,LogFileName,TemStr);
%
FileNamesIn=SetUpRadialFilesToClean(GlobalDirIn,SiteCode,RadialType,TemVecYearMonth);
%
for jfile=FileStartNum:1:NumMonths,
    %
    YearMonthToProcess=TemVecYearMonth(jfile,:);
    %
    if isequal(jfile,FileStartNum),
        StartClock=clock;
    end
    %
    AddLineToLog(GlobalDirOut,LogFileName,'*****');
    TemStr=['Starting Processing With File Number' num2str(jfile)];
    AddLineToLog(GlobalDirOut,LogFileName,TemStr);
    AddLineToLog(GlobalDirOut,LogFileName,'*****');
    %
    FileFound=1;
    %
    try
        load(FileNamesIn{jfile});
    catch
        FileFound=0;
    end
    %
    if FileFound,
        %
        [RadOut,RStatsOut]=CleanHFRadialsFirstOrder(Rorig,RadialStats,CleaningParameters);
        cd(GlobalDirOut);
        TemFileName=[upper(RadialSite) 'FirstOrderRadCleaned' RadialType 'Y' num2str(YearMonthToProcess(1)) 'M' num2str(YearMonthToProcess(2)) '.mat'];
        save(TemFileName,'RadOut','RStatsOut');
        %
        clear Rorig RadialStats Rcat RadOut RStatsOut
        %
        AddLineToLog(GlobalDirOut,LogFileName,'*****');
        TemStr=['Year ' num2str(YearMonthToProcess(1)) ' Month ' num2str(YearMonthToProcess(2)) ' Processed'];
        AddLineToLog(GlobalDirOut,LogFileName,TemStr);
        disp(TemStr)
        TemStr=['Month Number ' num2str(jfile)];
        AddLineToLog(GlobalDirOut,LogFileName,TemStr);
        AddLineToLog(GlobalDirOut,LogFileName,datestr(clock));
        %
        ElapsedTime=etime(clock,StartClock);
        ElapsedTime=(1/60)*ElapsedTime;
        %
        TemStr=['Elapsed Time in minutes since FileStartNum: ' num2str(ElapsedTime)];
        AddLineToLog(GlobalDirOut,LogFileName,TemStr);
        disp(TemStr)
        %
        AddLineToLog(GlobalDirOut,LogFileName,'*****');
        %
    else
        %
        AddLineToLog(GlobalDirOut,LogFileName,'*****');
        TemStr=['Year ' num2str(YearMonthToProcess(1)) ' Month ' num2str(YearMonthToProcess(2)) ' NOT FOUND !!!!'];
        AddLineToLog(GlobalDirOut,LogFileName,TemStr);
        disp(TemStr)
        TemStr=['Month Number ' num2str(jfile)];
        AddLineToLog(GlobalDirOut,LogFileName,TemStr);
        AddLineToLog(GlobalDirOut,LogFileName,datestr(clock));
        %
    end
    %
end
%
%  the routine is done
%
return;
%
function [FileNamesOut]=SetUpRadialFilesToClean(DirIn,SiteCode,RadialType,YearMonthMatrix)
%
%  [FileNamesOut]=SetUpRadialFileNames(DirIn,SiteCode,RadialType,YearM
%  onthMatrix);
%
%  To set up the Matlab file names for input
%
%  YearMonthMatrix has two columns corresponding to the month and the year
%
[NumTimes,numcols]=size(YearMonthMatrix);
FileNamesOut=cell(NumTimes,1);
%
DirSetUp=repmat(DirIn,NumTimes,1);
SiteSetUp=repmat(SiteCode,NumTimes,1);
RadsSetUp=repmat('FirstOrderStatsRads',NumTimes,1);
RadTypeSetUp=repmat(RadialType,NumTimes,1);
YearCharMat=repmat('Y',NumTimes,1);
MonthCharMat=repmat('M',NumTimes,1);
%
YearMat=cellstr(num2str(YearMonthMatrix(:,1)));
MonthMat=cellstr(num2str(YearMonthMatrix(:,2)));
%
%  the above pads the months with zeros!!!!!  Not Good.
%
%  Clugey fix
%
for jmonth=1:numel(MonthMat),
    if YearMonthMatrix(jmonth,2)<=9,
        MonthMat{jmonth}=num2str(YearMonthMatrix(jmonth,2));
    end
end
%
SuffixMat=repmat('.mat',NumTimes,1);
%
TemNames=strcat(SiteSetUp,RadsSetUp,RadTypeSetUp,YearCharMat,YearMat,MonthCharMat,MonthMat,SuffixMat);
FileNamesOut=fullfile_multiple(DirSetUp,TemNames);
%
return;
%
