function [RcatOut]=GenericSecOrderRadialsStatsLoad(RadialSite,RadialType,FileNumToLoad,YearToLoad)
%
%  [RcatOut]=GenericSecOrderRadialsStatsLoad(RadialSite,RadialType,FileNumToLoad,YearToLoad);
%
%  To load the first order stats so we can investigate the obtaining of
%  stats for second order cleaning.  PAFS is hanging up for some reason -
%  file 1 doesn't return from the stats obtaining routine.
%
%  Let's compare BMLR and PAFS to see what is going on.
%
%  to load the first order statistics, clean the radials, get second order stats,
%  clean the radials, and save those  (this is alot!  Let's see how it
%  goes)
%
%  parameters For the first Order cleaning of radials:
%
%  Note: decrease in range generally not bad, so those flags left off in
%  the above.  Should really add for completeness, as well as the perdiff
%  flags.
%
%  YearToLoad added b/c we now have 2006 data locally
%
InitialCleaningParameters={'BML1',[0.5],'DataFound','BelowBad';'BML1',[0.5],'MatchingTimeStamps','BelowBad';...
    'PRey',[0.5],'DataFound','BelowBad';'PRey',[0.5],'MatchingTimeStamps','BelowBad';...
    'GCve',[0.5],'DataFound','BelowBad';'GCve',[0.5],'MatchingTimeStamps','BelowBad';...
    'SLID',[0.5],'DataFound','BelowBad';'SLID',[0.5],'MatchingTimeStamps','BelowBad';...
    'COMM',[0.5],'DataFound','BelowBad';'COMM',[0.5],'MatchingTimeStamps','BelowBad';...
    'MONT',[0.5],'DataFound','BelowBad';'MONT',[0.5],'MatchingTimeStamps','BelowBad';...
    'FORT',[0.5],'DataFound','BelowBad';'FORT',[0.5],'MatchingTimeStamps','BelowBad';...
    'BMLR',[0.5],'DataFound','BelowBad';'BMLR',[0.5],'MatchingTimeStamps','BelowBad';...
    'PAFS',[0.5],'DataFound','BelowBad';'PAFS',[0.5],'MatchingTimeStamps','BelowBad'};
%
%  Put the second order cleaning stats here! (no - add to the directory
%  structure)
%
%  Standard Range:
%
%MaxGapTDiff=4;
%PerCovWindowSearch=8;
%SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
%
% Long Range
%
%SecOrderCleaningParameters={'No',[0.0019],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
%
%  Put the directory structure and time limits here!
%
switch upper(RadialType)
    case 'IDEAL'
        RadialType='Ideal';
    otherwise
        RadialType='Measured';
end
%
if exist('YearToLoad','var'),
    GlobalDirIn=cell(1,1);
    GlobalDirIn{1}=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) num2str(YearToLoad) '/Matlab/' RadialType '/FirstOrderStats/'];
    GlobalDirOut=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) num2str(YearToLoad) '/Matlab/' RadialType '/CleanedSecondOrder/'];
else
    GlobalDirIn=cell(1,1);
    GlobalDirIn{1}=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) '/Matlab/' RadialType '/FirstOrderStats/'];
    GlobalDirOut=['/Users/chrishalle/Documents/CODARData/Radials/' upper(RadialSite) '/Matlab/' RadialType '/CleanedSecondOrder/'];
end
%
if ~exist(GlobalDirOut,'dir'),
    %
    [SUCCESS,MESSAGE,MESSAGEID] = mkdir(GlobalDirOut);
    if ~SUCCESS,
        disp('creation of output directory failed')
        disp('routine ending')
        return;
    end
end
%
if exist('YearToLoad','var'),
    RadialSiteTem=[RadialSite num2str(YearToLoad)];
else
    RadialSiteTem=RadialSite;
end
%
switch upper(RadialSiteTem)
    case 'SLID'
        SiteCode={'SLID'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CMHToolbox/NationalParkStudy/SLIDRadialMask.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2008 3 30 7];  % really only need to enter year and month of start times, but keep this way for ease
            EndDate=[2008 6 4 14];
        else
            StartDate=[2008 3 30 7];
            EndDate=[2008 6 4 14];
        end
    case 'COMM'
        SiteCode={'COMM'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CMHToolbox/NationalParkStudy/COMMRadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 5 31 19];
            EndDate=[2008 5 1 17];
        else
            StartDate=[2006 7 21 0];
            EndDate=[2008 5 1 17];
        end
    case 'MONT'
        SiteCode={'MONT'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CMHToolbox/NationalParkStudy/MONTRadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 6 6 22];
            EndDate=[2008 5 11 3];
        else
            StartDate=[2006 7 21 0];
            EndDate=[2008 4 30 22];
        end
    case 'FORT'
        SiteCode={'FORT'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CMHToolbox/NationalParkStudy/FORTRadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 8 1 15];
            EndDate=[2008 5 15 16];
        else
            StartDate=[2006 7 21 0];
            EndDate=[2008 5 15 16];
        end
    case 'BMLR'
        SiteCode={'BMLR'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/LongRangeNearBML/ProcessingInfo/BMLRRadialMask.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.0019],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};   % different for long range
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 2 3 20];
            EndDate=[2008 6 12 20];
        else
            StartDate=[2007 2 3 20];
            EndDate=[2008 6 12 20];
        end
    case 'PAFS'
        %
        SiteCode={'PAFS'};
        Spacing=1;  % in hours
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/LongRangeNearBML/ProcessingInfo/MENDRadialMask.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.0019],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'}; % different for long range
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 6 15 1];
            EndDate=[2008 6 12 21];
        else
            StartDate=[2007 6 15 20];
            EndDate=[2008 6 12 21];
        end
    case 'BML1'
        SiteCode={'BML1'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/StandardRangeNearBML/ProcessingInfo/BMLRadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 1 1 0];
            EndDate=[2008 6 12 20];
        else
            StartDate=[2007 1 1 0];
            EndDate=[2008 6 12 20];
        end
    case 'GCVE'
        SiteCode={'GCve'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/StandardRangeNearBML/ProcessingInfo/GCVERadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 3 8 6];
            EndDate=[2008 5 9 18];
        else
            StartDate=[2007 3 8 6];
            EndDate=[2008 5 9 18];
        end
    case 'PREY'
        SiteCode={'PRey'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/StandardRangeNearBML/ProcessingInfo/PREYRadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2007 1 1 0];
            EndDate=[2008 6 12 22];
        else
            StartDate=[2007 1 1 0];
            EndDate=[2008 6 5 22];
        end
    case 'BML12006'
        SiteCode={'BML1'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/StandardRangeNearBML/ProcessingInfo/BMLRadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 8];
            EndDate=[2006 12 31 23];
        else
            StartDate=[2006 1 1 8];
            EndDate=[2006 12 31 23];
        end
    case 'GCVE2006'
        SiteCode={'GCve'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/StandardRangeNearBML/ProcessingInfo/GCVERadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 1 8];
            EndDate=[2006 11 18 20];
        else
            StartDate=[2006 1 1 8];
            EndDate=[2006 11 18 20];
        end
    case 'PREY2006'
        SiteCode={'PRey'};
        Spacing=1;  % in hours, just used to get time axis - clugey, based on old code
        RadialMaskFile={'/Users/chrishalle/Documents/CODARData/StandardRangeNearBML/ProcessingInfo/PREYRadMaskIn.txt'}; % !!!!  change
        MaxGapTDiff=4;
        PerCovWindowSearch=8;
        SecOrderCleaningParameters={'No',[0.003],'MinTotDiff','AboveBad';'No',[35],'PerCovMax','BelowBad'};
        if isequal(RadialType,'Ideal'),
            StartDate=[2006 1 6 2];
            EndDate=[2006 12 31 23];
        else
            StartDate=[2006 1 6 2];
            EndDate=[2006 12 31 23];
        end
    otherwise
        disp('other sites not set up yet')
        disp('routine ending')
end
%
%  Loop through and load the files.
%  We will have to load files before and afterward to calculate the
%  statistics.  Extract the portions we need, concatenate, get statistics, then parse out the 
%  times we need.
%
%
LogFileName=[upper(RadialSite) 'LogSecOrderRadLoadTest' datestr(clock,30) '.txt'];  % the log file
%
%  Set up the year / month time axis to load (will correspond to the file
%  names)
%
TemStart=datenum([StartDate 0 0]);
TemEnd=datenum([EndDate 0 0]);
TimeVect=TemStart:Spacing/24:TemEnd;
TemVec=datevec(TimeVect);
%
%  problem!!!! datevec routine sometimes gives 59 minutes and 60 seconds
%  instead of converting to the next hour....  check this.
%
temmark=find((TemVec(:,5)>58)&(TemVec(:,6)>58));
if numel(temmark)>0,
    disp('converting some times to next highest hour')
    disp('standard Matlab issue with datevec command')
    TemVec(temmark,4)=TemVec(temmark,4)+1;
    TemVec(temmark,5)=0;
    TemVec(temmark,6)=0;
end
%
TemVec=round(TemVec);
%
TemVecYearMonth=TemVec(:,1:2);
TemVecYearMonth=unique(TemVecYearMonth,'rows');
[NumMonths,NumCols]=size(TemVecYearMonth);
%
TemStr=['Number of Months To Process: ' num2str(NumMonths)];
AddLineToLog(GlobalDirOut,LogFileName,TemStr);
%
FileNamesIn=SetUpRadialFilesToSecOrderClean(GlobalDirIn,SiteCode,RadialType,TemVecYearMonth);
%
for jfile=FileNumToLoad:1:FileNumToLoad,
    %
    YearMonthToProcess=TemVecYearMonth(jfile,:);
    %
    AddLineToLog(GlobalDirOut,LogFileName,'*****');
    TemStr=['Starting Processing With File Number' num2str(jfile)];
    AddLineToLog(GlobalDirOut,LogFileName,TemStr);
    %
    FileFound=1;
    %
    try
        load(FileNamesIn{jfile});
        RorigCurrent=Rorig;
        RadStatsCurrent=RadialStats;
        clear Rorig RadialStats
        %
        %  get the filenames associated with the loading, so that we can
        %  keep only the relevant portions later
        %
    catch
        FileFound=0;
    end
    %
    if FileFound,
        %
        %  Load the file before, if possible
        %
        if jfile>1,
            try
               %
               load(FileNamesIn{jfile-1});
               RorigBefore=Rorig;
               RadStatsBefore=RadialStats;
               clear Rorig RadialStats
               %
               [DataBefore,SuccessSwitch]=ExtractData(RorigBefore,RorigCurrent,PerCovWindowSearch+2,'END');
               %
               if SuccessSwitch,
                   RorigCurrent=[DataBefore;RorigCurrent];
               end
               %
               [DataBefore,SuccessSwitch]=ExtractStatsData(RadStatsBefore,RadStatsCurrent,PerCovWindowSearch+2,'END');
               %
               if SuccessSwitch,
                   [RadStatsCurrent]=AppendHFRadarStats(RadStatsBefore,RadStatsCurrent);
               end
               %
               clear RorigBefore DataBefore RadStatsBefore
               %
            catch
                %  do nothing
            end
        end
        %
        %  Load the file after, if possible
        %
        if jfile<NumMonths,
            try
               %
               load(FileNamesIn{jfile+1});
               RorigAfter=Rorig;
               RadStatsAfter=RadialStats;
               clear Rorig RadialStats
               %
               [DataAfter,SuccessSwitch]=ExtractData(RorigAfter,RorigCurrent,PerCovWindowSearch+2,'START');
               %
               if SuccessSwitch,
                   RorigCurrent=[RorigCurrent;DataAfter];
               end
               %
               [DataAfter,SuccessSwitch]=ExtractStatsData(RadStatsAfter,RadStatsCurrent,PerCovWindowSearch+2,'START');
               %
               if SuccessSwitch,
                   [RadStatsCurrent]=AppendHFRadarStats(RadStatsCurrent,RadStatsAfter);
               end
               %
               clear RorigAfter DataAfter RadStatsAfter
               %
            catch
                %  do nothing
            end
        end
        %
        %  now clean the radials
        %
        %  Empties are stripped in the routine below
        %  (CleanHFRadialsFirstOrder)
        %
        TemStr=[upper(RadialSite) ' ' RadialType 'File Number ' num2str(jfile) ' of ' num2str(NumMonths) ' Loaded'];
        disp(TemStr)
        %
        [RadOut,RStatsOut]=CleanHFRadialsFirstOrder(RorigCurrent,RadStatsCurrent,InitialCleaningParameters);
        %
        AddLineToLog(GlobalDirOut,LogFileName,'RadialsFirstOrderCleaned');
        %
        TemStr=[upper(RadialSite) ' ' RadialType 'File Number ' num2str(jfile) ' of ' num2str(NumMonths) ' FirstOrderCleaned'];
        disp(TemStr)
        %
        clear RorigCurrent RadStatsCurrent RStatsOut
        %
        %  mask the radials - makes the following calculations, etc.,
        %  faster
        %
        [RadOut,II]=maskRadials(RadOut,RadialMaskFile{1},true);
        %
        TemStr=[upper(RadialSite) ' ' RadialType 'File Number ' num2str(jfile) ' of ' num2str(NumMonths) ' Masked'];
        disp(TemStr);
        %
        RcatOut = temporalConcatRadials( RadOut, 0.001, 0.49, 0.49, 0.5 );
        %
        %  the routine is done
        %
    else
        RcatOut=NaN;
    end
    %
end
%
%  the routine is done
%
return;
%
function [FileNamesOut]=SetUpRadialFilesToSecOrderClean(DirIn,SiteCode,RadialType,YearMonthMatrix)
%
%  [FileNamesOut]=SetUpRadialFileNames(DirIn,SiteCode,RadialType,YearM
%  onthMatrix);
%
%  To set up the Matlab file names for input
%
%  YearMonthMatrix has two columns corresponding to the month and the year
%
[NumTimes,numcols]=size(YearMonthMatrix);
FileNamesOut=cell(NumTimes,1);
%
DirSetUp=repmat(DirIn,NumTimes,1);
SiteSetUp=repmat(SiteCode,NumTimes,1);
RadsSetUp=repmat('FirstOrderStatsRads',NumTimes,1);
RadTypeSetUp=repmat(RadialType,NumTimes,1);
YearCharMat=repmat('Y',NumTimes,1);
MonthCharMat=repmat('M',NumTimes,1);
%
YearMat=cellstr(num2str(YearMonthMatrix(:,1)));
MonthMat=cellstr(num2str(YearMonthMatrix(:,2)));
%
%  the above pads the months with zeros!!!!!  Not Good.
%
%  Clugey fix
%
for jmonth=1:numel(MonthMat),
    if YearMonthMatrix(jmonth,2)<=9,
        MonthMat{jmonth}=num2str(YearMonthMatrix(jmonth,2));
    end
end
%
SuffixMat=repmat('.mat',NumTimes,1);
%
TemNames=strcat(SiteSetUp,RadsSetUp,RadTypeSetUp,YearCharMat,YearMat,MonthCharMat,MonthMat,SuffixMat);
FileNamesOut=fullfile_multiple(DirSetUp,TemNames);
%
return;
%
function [DataOut,SuccessSwitch]=ExtractData(RadialsToExtract,CurrentSetOfRadials,HoursToExtract,ExtractSwitch)
%
%  [DataOut,SuccessSwitch]=ExtractData(RadialsToExtract,CurrentSetOfRadials,HoursToExtrac
%  t,ExtractSwitch);
%
%  To Extract "HoursToExtract" data.  
%
%  If ExtractSwitch is 'START', then the
%  start portion of RadialsToExtract is extracted, will be concatenated to
%  the end of CurrentSetOfRadials later.
%
%  If ExtractSwitch is 'END', then the
%  end portion of RadialsToExtract is extracted, will be stuck onto the front of 
%  CurrentSetOfRadials later.
%
%  TimeToExtract is based on the start or stop time of CurrentSetOfRadials
%  plus or minus HoursToExtract
%
%  Get the times associated with the current radial structure.  Quick but crude -
%  not assuming in time order here for some reason.
%
TimesOfCurrentRadials=NaN*ones(numel(CurrentSetOfRadials),1);
%
for jrad=1:numel(CurrentSetOfRadials),
    TimesOfCurrentRadials(jrad)=CurrentSetOfRadials(jrad).TimeStamp;
end
%
%  Get the times associated with RadialsToExtract
%
TimesOfRadialsToExtract=NaN*ones(numel(RadialsToExtract),1);
%
for jrad=1:numel(RadialsToExtract),
    TimesOfRadialsToExtract(jrad)=RadialsToExtract(jrad).TimeStamp;
end
%
switch upper(ExtractSwitch)
    case 'START'
        %
        TimeCut=nanmax(TimesOfCurrentRadials)+((1/24)*HoursToExtract)+0.005;  %just in case of roundoff
        %
        TimeIndices=find(TimesOfRadialsToExtract<=TimeCut);
        %
    case 'END'
        %
        TimeCut=nanmin(TimesOfCurrentRadials)-((1/24)*HoursToExtract)-0.005;  %just in case of roundoff
        %
        TimeIndices=find(TimesOfRadialsToExtract>=TimeCut);
        %
end
%
if numel(TimeIndices)>=1,
    %
    DataOut=RadialsToExtract(TimeIndices);
    SuccessSwitch=1;
    %
else
    %
    DataOut=NaN;
    SuccessSwitch=0;
    %
end
%
%  the routine is done
%
return;
%
function [DataOut,SuccessSwitch]=ExtractStatsData(StatsToExtract,CurrentSetOfStats,HoursToExtract,ExtractSwitch)
%
%  [DataOut,SuccessSwitch]=ExtractStatsData(StatsToExtract,CurrentSetOfStat
%  s,HoursToExtract,ExtractSwitch);
%
%  To Extract "HoursToExtract" data.  
%
%  If ExtractSwitch is 'START', then the
%  start portion of StatsToExtract is extracted, will be concatenated to
%  the end of CurrentSetOfStats later.
%
%  If ExtractSwitch is 'END', then the
%  end portion of StatsToExtract is extracted, will be stuck onto the front of 
%  CurrentSetOfStats later.
%
%  TimeToExtract is based on the start or stop time of CurrentSetOfStats
%  plus or minus HoursToExtract
%
%  Get the times associated with the current stats structure.  Quick but crude -
%  not assuming in time order here for some reason.
%
%  Assuming time stamps match here!!!!!  So if mismatch, the problem has
%  been fixed.
%
switch upper(ExtractSwitch)
    case 'START'
        %
        TimeCut=nanmax(CurrentSetOfStats.FileTimeStamp)+((1/24)*HoursToExtract)+0.005;  %just in case of roundoff
        %
        TimeIndices=find(StatsToExtract.FileTimeStamp<=TimeCut);
        %
    case 'END'
        %
        TimeCut=nanmin(CurrentSetOfStats.FileTimeStamp)-((1/24)*HoursToExtract)-0.005;  %just in case of roundoff
        %
        TimeIndices=find(StatsToExtract.FileTimeStamp>=TimeCut);
        %
end
%
if numel(TimeIndices)>=1,
    %
    [DataOut]=ExtractFieldsFromStruct(StatsToExtract,TimeIndices,1);
    SuccessSwitch=1;
    %
else
    %
    DataOut=NaN;
    SuccessSwitch=0;
    %
end
%
%  the routine is done
%
return;
%
function [RcatOut]=ExtractRelevantMonthlyData(RcatIn,YearMonthToExtract)
%
%  [RcatOut]=ExtractRelevantMonthlyData(RcatIn,YearMonthToExtract);
%
%  Extract the dat abased on the Year and Month
%
%  works only based on year and month (don't pass multiple years)
%
TemTimeAxis=RcatIn.TimeStamp';
%
TemVec=datevec(TemTimeAxis);
%
%  problem!!!! datevec routine sometimes gives 59 minutes and 60 seconds
%  instead of converting to the next hour....  check this.
%
temmark=find((TemVec(:,5)>58)&(TemVec(:,6)>58));
if numel(temmark)>0,
    disp('converting some times to next highest hour')
    disp('standard Matlab issue with datevec command')
    TemVec(temmark,4)=TemVec(temmark,4)+1;
    TemVec(temmark,5)=0;
    TemVec(temmark,6)=0;
end
%
TemVec=round(TemVec);
%
TemVecYearMonth=TemVec(:,1:2);
%
TimeIndices=find(ismember(TemVecYearMonth,YearMonthToExtract,'rows'));
%
if numel(TimeIndices)<1,
    RcatOut=NaN;
else
    [NumPoints,NumCols]=size(RcatIn.LonLat);
    RcatOut=subsrefRADIAL(RcatIn,[1:NumPoints],TimeIndices);
end
%
%  the routine is done
%
return;
%
