function [FormPlots]=MakeSatPlotsNew(DataDir,DataType,LonLimits,LatLimits,DateStart,DateEnd)
%
%  [FormPlots]=MakeSatPlotsNew(DataDir,DataType,LonLims,LatLims,DateStart,D
%  ateEnd);
%
%  Makes a new directory /Images!  Old pictures are overwritten, bt not
%  deleted.
%
DirOut=fullfile(DataDir,'Images');
%
if ~exist(DirOut,'dir'),
    %
    [SUCCESS,MESSAGE,MESSAGEID] = mkdir(DirOut);
    if ~SUCCESS,
        disp('creation of output directory for failed')
        disp('routine ending')
        FormPlots=0;
        return;
    end
end
%
switch upper(DataType)
    case 'AVHRRSST3DAY'
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];
    case 'AQUACHL3DAY'
        ParamFileStart='CHL3Day';
        ParamVarName='MYchla';
        ParamContourLevels=[8:0.5:20];

        DataSet='TMYchla';
        AverageTtype='3day';
        ParamVarName='MYchla';
        FirstFilePartName='CHL3Day';
        HourStamp='12';
    case 'EXPAQUACHL3DAY'  % sensor on a different satellite?
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TMWchla';
        AverageTtype='3day';
        ParamVarName='MWchla';
        FirstFilePartName='EXPCHL3Day';
        HourStamp='12';
    case 'BLENDEDSST5DAY'
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TBAssta';
        AverageTtype='5day';
        ParamVarName='BAssta';
        FirstFilePartName='BLNDSST5Day';
        HourStamp='12';
    case 'GOESSST3DAY'
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TGAssta';
        AverageTtype='3day';
        ParamVarName='GAssta';
        FirstFilePartName='GOESSST3Day';
        HourStamp='12';
    case 'ZONALBLENDEDWIND1DAY'
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TNWuuuu';
        AverageTtype='1day';
        ParamVarName='NWuuuu';
        FirstFilePartName='BLNDZONWIND1Day';
        HourStamp='09';
    case 'MERIDIONALBLENDEDWIND1DAY'
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TNWvvvv';
        AverageTtype='1day';
        ParamVarName='NWvvvv';
        FirstFilePartName='BLNDMERWIND1Day';
        HourStamp='09';
    case 'ZONALQSCATWINDS1DAY'
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TQNux10';
        AverageTtype='1day';
        ParamVarName='QNux10';
        FirstFilePartName='QSCATZONWIND1Day';
        HourStamp='12';
    case 'MERIDIONALQSCATWINDS1DAY'
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TQNuy10';
        AverageTtype='1day';
        ParamVarName='QNuy10';
        FirstFilePartName='QSCATMERWIND1Day';
        HourStamp='12';
    case 'ZONALQSCATWINDS3DAY'
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TQNux10';
        AverageTtype='3day';
        ParamVarName='QNux10';
        FirstFilePartName='QSCATZONWIND3Day';
        HourStamp='12';
    case 'MERIDIONALQSCATWINDS3DAY'
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TQNuy10';
        AverageTtype='3day';
        ParamVarName='QNuy10';
        FirstFilePartName='QSCATMERWIND3Day';
        HourStamp='12';
    case 'AVISOSSH1DAY'
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TTAsshl';
        AverageTtype='1day';
        ParamVarName='TAsshl';
        FirstFilePartName='SSH1Day';
        HourStamp='12';
    case 'AVISOSSHDEVIATION1DAY'
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TTAsshd';
        AverageTtype='1day';
        ParamVarName='TAsshd';
        FirstFilePartName='SSHDev1DDay';
        HourStamp='12';
    case 'CHLSEAWIFS3DAY'  % data ends in March 2009
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TSHchl2';
        AverageTtype='3day';
        ParamVarName='SHchl2';
        FirstFilePartName='SWIFS3Day';
        HourStamp='12';
    case 'CHLADEVIATIONSEAWIFS8DAY' % data ends in March 2009
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TSHcde2';
        AverageTtype='8day';
        ParamVarName='SHcde2';
        FirstFilePartName='SWIFSDev8Day';
        HourStamp='00';
    case 'ZONGEOCURRENTS1DAY'  %  as of Jul 2009, data available until Dec 2008
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TTAugeo';
        AverageTtype='1day';
        ParamVarName='TAugeo';
        FirstFilePartName='GEOCurrZon1Day';
        HourStamp='12';
    case 'MERGEOCURRENTS1DAY'
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];

        DataSet='TTAvgeo';
        AverageTtype='1day';
        ParamVarName='TAvgeo';
        FirstFilePartName='GEOCurrMer1Day';
        HourStamp='12';
    otherwise
        disp('unknown option chosen')
        disp('routine ending')
        return;
end
%








LonLimits=[-126 -122];
LatLimits=[37 40];
%
DirInTemp=fullfile('/Users/chrishalle/Documents/CODARData','MISCSatData','SeaSurfaceTempData');
DirInChl=fullfile('/Users/chrishalle/Documents/CODARData','MISCSatData','ChlData');
%
DirOutTemp=fullfile('/Users/chrishalle/Documents/CODARData','MISCSatData','SeaSurfaceTempData','Images');
DirOutChl=fullfile('/Users/chrishalle/Documents/CODARData','MISCSatData','ChlData','Images');
%
CoastFile=fullfile('/Users/chrishalle/Documents/CODARData/Totals/StatewideFromSYKim/ProcessingInfo','WestCoastMap.mat');
%
if ~exist(DirOutTemp,'dir'),
    %
    [SUCCESS,MESSAGE,MESSAGEID] = mkdir(DirOutTemp);
    if ~SUCCESS,
        disp('creation of output directory for sat. temps failed')
        disp('routine ending')
        FormPlots=0;
        return;
    end
end
%
if ~exist(DirOutChl,'dir'),
    %
    [SUCCESS,MESSAGE,MESSAGEID] = mkdir(DirOutChl);
    if ~SUCCESS,
        disp('creation of output directory for sat. temps failed')
        disp('routine ending')
        FormPlots=0;
        return;
    end
end
%
StartDateNum=datenum([DateStart 12 0 0]);
EndDateNum=datenum([DateEnd 12 0 0]);
%
TimeAxisToRetrieve=StartDateNum:1:EndDateNum;
%
TimeVectToRetrieve=datevec(TimeAxisToRetrieve);
%
Create3DailyAveragedFigures(DirInTemp,DirOutTemp,'SST',TimeVectToRetrieve,LonLimits,LatLimits,CoastFile);
Create3DailyAveragedFigures(DirInChl,DirOutChl,'CHL',TimeVectToRetrieve,LonLimits,LatLimits,CoastFile);
%
FormPlots=1;
%
%  the routine is done
%
return;
%
function Create3DailyAveragedFigures(DirIn,DirOut,ParamToPlot,TimeVectToRetrieve,LonLimits,LatLimits,CoastFile)
%
%  Create3DailyAveragedFigures(DirIn,DirOut,ParamToPlot,TimeVectToRetrieve,
%  LonLimits,LatLimits,CoastFile);
%
%  loop through, generate the temp plots
%
%  Do both low resolution currents and high resolution
%
switch upper(ParamToPlot)
    case 'SST'
        ParamFileStart='SST3Day';
        ParamVarName='ATssta';
        ParamContourLevels=[8:0.5:20];
    case 'CHL'
        ParamFileStart='CHL3Day';
        ParamVarName='MYchla';
        ParamContourLevels=[-1:0.5:3];
end
%
[NumTimes,NumCols]=size(TimeVectToRetrieve);
%
for jtime=1:NumTimes,
    %
    TemFigHandle=figure;
    %
    plotBasemap(LonLimits,LatLimits,CoastFile,'lambert', 'patch', [0.5 0.5 0.5] );
    hold
    xlabel('longitude, (degrees)','FontSize',[12],'FontWeight','bold')
    ylabel('latitude, (degrees)','FontSize',[12],'FontWeight','bold')
    %
    TemTitle=[ParamFileStart ' ' datestr(datenum(TimeVectToRetrieve(jtime,:)),1)];
    title(TemTitle);
    %
    cd(DirIn);
    %
    if TimeVectToRetrieve(jtime,2)<10,
        MonthPart=['0' num2str(TimeVectToRetrieve(jtime,2),1)];
    else
        MonthPart=num2str(TimeVectToRetrieve(jtime,2),2);
    end
    %
    if TimeVectToRetrieve(jtime,3)<10,
        DayPart=['0' num2str(TimeVectToRetrieve(jtime,3),1)];
    else
        DayPart=num2str(TimeVectToRetrieve(jtime,3),2);
    end
    %
    YearPart=num2str(TimeVectToRetrieve(jtime,1),4);
    %
    FileToImport=[ParamFileStart YearPart 'M' MonthPart 'D' DayPart 'H12UTC.mat'];
    %
    try
       load(FileToImport);
    catch
        lon=1:10;
        lat=1:3;
        eval([ParamVarName '=NaN*ones(3,10);'])
    end
    %
    eval(['DataToPlot=' ParamVarName ';'])
    eval(['clear ' ParamVarName])
    %
    temmark=find(DataToPlot>max(ParamContourLevels));
    if numel(temmark)>0,
        DataToPlot(temmark)=max(ParamContourLevels);
    end
    %
    temmark=find(DataToPlot<min(ParamContourLevels));
    if numel(temmark)>0,
        DataToPlot(temmark)=min(ParamContourLevels);
    end
    %
    if sum(sum(isfinite(DataToPlot)))>0,
        [cs,h]=m_contourf(lon,lat,DataToPlot,ParamContourLevels);
    end
    %
    caxis([min(ParamContourLevels) max(ParamContourLevels)])
    colorbar('vert')
    %
    TemFigName=[ParamToPlot num2str(TimeVectToRetrieve(jtime,1)) 'M' num2str(TimeVectToRetrieve(jtime,2)) 'D' num2str(TimeVectToRetrieve(jtime,3)) 'H12GMT.jpg'];
    %
    cd(DirOut);
    %
    saveas(TemFigHandle,TemFigName,'jpg');
    pause(2);
    delete(TemFigHandle);
    %
end
%
%  the routine is done
%
return;
%
