%
%  Get the grid based on Long Range and BML for areas up here
%  Then save the rest, use masks after the fact to exclude "bad" areas
%
%  Also cut off grids too far to the north
%
%
%  Initial PAFSToPSURGrid
%
DirIn='/Users/chrishalle/Documents/CODARData/Totals/PSURToPAFS/ProcessingInfo/';
FileIn='InitialPSURToPAFSGrid.txt';
%
GridFile=[DirIn FileIn];
%
[InitialGrid,fn,c] = loadDataFileWithChecks(GridFile);
%
%  
%  Long Range Grid - do not need exclusion zones, etc., with this one
%
DirIn='/Users/chrishalle/Documents/CODARData/LongRangeNearBML/ProcessingInfo/';
FileIn='LongRangeGrid5kmVer2.txt';
%
GridFile=[DirIn FileIn];
%
[LongRangeGrid,fn,c] = loadDataFileWithChecks(GridFile);
%
%
%  BML Standard Range Grid - should not need exclusion zones, etc.
%
DirIn='/Users/chrishalle/Documents/CODARData/StandardRangeNearBML/ProcessingInfo/';
FileIn='StanRange2kmGridInitial.txt';
%
GridFile=[DirIn FileIn];
%
[BMLStandardGrid,fn,c] = loadDataFileWithChecks(GridFile);
%
TUVTem=TUVstruct([numel(LongRangeGrid(:,1)) 1]);
TUVTem.U=ones(numel(LongRangeGrid(:,1)),1);
TUVTem.V=ones(numel(LongRangeGrid(:,1)),1);
TUVTem.LonLat=LongRangeGrid;
[LongRangeCoverage]=FindHFBoundingRegion(TUVTem,1);
%
TUVTem=TUVstruct([numel(BMLStandardGrid(:,1)) 1]);
TUVTem.U=ones(numel(BMLStandardGrid(:,1)),1);
TUVTem.V=ones(numel(BMLStandardGrid(:,1)),1);
TUVTem.LonLat=BMLStandardGrid;
[BMLStandardRangeCoverage]=FindHFBoundingRegion(TUVTem,1);
%
%  Set up an index to keep.  Default is to keep all grids
%
IndexToKeep=ones(numel(InitialGrid(:,1)),1);
%
TooFarNorth=find((InitialGrid(:,2)>max(BMLStandardRangeCoverage(:,2)))&(InitialGrid(:,2)>max(LongRangeCoverage(:,2))));
%
if numel(TooFarNorth)>0,
    IndexToKeep(TooFarNorth)=0;
    temmark=find(IndexToKeep>0);
    InitialGrid=InitialGrid(temmark,:);
end
%
%  north of lat 38 (Point Reyes), only keep points that are in one or more of the coverage
%  grids
%
Northof38=find(InitialGrid(:,2)>=38);
%
InLongRange=inpolygon(InitialGrid(Northof38,1),InitialGrid(Northof38,2),LongRangeCoverage(:,1),LongRangeCoverage(:,2));
InStandardRange=inpolygon(InitialGrid(Northof38,1),InitialGrid(Northof38,2),BMLStandardRangeCoverage(:,1),BMLStandardRangeCoverage(:,2));
%
GridsToKeep=sign(InLongRange+InStandardRange);
GridsToExclude=~sign(InLongRange+InStandardRange);
%
temmark=find(GridsToExclude>0);
InitialGrid(Northof38(temmark),:)=NaN;
%
temmark=find(~isnan(InitialGrid(:,1)));
InitialGrid=InitialGrid(temmark,:);
%
DirOut='/Users/chrishalle/Documents/CODARData/Totals/PSURToPAFS/ProcessingInfo/';
cd(DirOut);
%
[yout]=PutOutTextFile4sig(InitialGrid,'PAFSToPSURGRidBMLRegionGood.txt');
%
