function RenameRadialruxFiles(SiteDir,RadialType)
%
%  RenameRadialruxFiles(SiteDir,RadialType);
%
%  Renames the files so that the files saved with .rux.ruv are changed to
%  .ruv
%
%  SiteDir can be 'BML12006', 'GCVE2006', or 'PREY2006'
%
BaseDir='/Users/chrishalle/Documents/CODARData/Radials/';
%
switch upper(RadialType)
    case 'IDEAL'
        DirIn=[BaseDir upper(SiteDir) '/IdealAll/'];
    otherwise
        DirIn=[BaseDir upper(SiteDir) '/MeasuredAll/'];
end
%
cd(DirIn);
%
TemDir=dir;
%
LogFileName=[upper(SiteDir) 'RenameRuxLog.txt'];
%
TemStr=['Beginning Search to Rename Files: ' datestr(now)];
AddLineToLog(DirIn,LogFileName,TemStr);
TemStr='******';
AddLineToLog(DirIn,LogFileName,TemStr);
TemStr='    ';
AddLineToLog(DirIn,LogFileName,TemStr);
%
%  loop through and rename if necessary
%
for jdir=1:numel(TemDir),
    %
    if isequal(rem(jdir,100),0),
        TemStr=['Checking File ' num2str(jdir) ' of ' num2str(numel(TemDir)) ' Files'];
        disp(TemStr)
    end
    if ~TemDir(jdir).isdir,
        if numel(TemDir(jdir).name)>15,
            TemName=TemDir(jdir).name;
            NumChars=numel(TemName);
            if isequal(TemName(NumChars-7+1:NumChars),'.rx.ruv'),
                TemName2=[TemName(1:NumChars-7) '.ruv'];
                TemStr=['Renaming:  File In : ' TemName];
                disp(TemStr)
                AddLineToLog(DirIn,LogFileName,TemStr);
                movefile(TemName,TemName2);
            end
        end
    end
end
%
%  the routine is done
%
return;
%
